package ru.dbotthepony.kstarbound.defs.item

import com.google.common.collect.ImmutableList
import ru.dbotthepony.kstarbound.defs.IThingWithDescription
import ru.dbotthepony.kstarbound.defs.ThingDescription
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory
import ru.dbotthepony.kstarbound.io.json.builder.JsonPropertyConfig

data class ItemDefinition(
	override val itemName: String,
	override val price: Long = 4L,
	override val rarity: ItemRarity,
	override val category: String?,
	override val inventoryIcon: ImmutableList<out IItemDefinition.IInventoryIcon>?,
	override val itemTags: ImmutableList<String>,
	override val learnBlueprintsOnPickup: ImmutableList<String>,
	override val maxStack: Long,
	override val eventCategory: String?,
	override val consumeOnPickup: Boolean,
	override val pickupQuestTemplates: ImmutableList<String>,
	override val tooltipKind: ItemTooltipKind,
	override val twoHanded: Boolean,
	override val radioMessagesOnPickup: ImmutableList<String>,
	override val fuelAmount: Long?,

	val descriptionData: ThingDescription,

	val json: Map<String, Any>
) : IItemDefinition, IThingWithDescription by descriptionData
